function RegisterService(){
    if(arguments.callee._singletonInstance){
	    return arguments.callee._singletonInstance;
	}
	arguments.callee._singletonInstance = this;

	var self = this; self.name = "RegisterService"; // MANDATORY

    this.api_key = 0;
    this.registered = false;
    this.registerCompleteCallback = false;
    this.checking_time = false;
    this.project_id = 0;

    this.readLicense = function(){
        if(!self.checking_time){
            self.OS.fileExists(self.ROUTES['LICENSE'].path,function(exists,file_ref,params){
                if(exists){
                    self.OS.readFile(self.ROUTES['LICENSE'].path,function(data,file_ref,params){
                        if(data != ""){
                            self.api_key = data.replace(/[^a-zA-Z0-9]/g, '');
                            self.setApiKey(self.api_key)
                            self.log("Admira License exists : "+self.api_key);
                            self.register();
                        }else{
                            self.log("Admira License exists but has no data ... ");
                            self.notifyError(self.ERROR['REGISTER_SERVICE']+1,self.name+": Function readLicense() failed : Admira License exists but has no data ...");
                        }
                    });
                }else{
                    self.log("Admira License DOES NOT EXIST ...");
                    self.log("Admira License exists but has no data ... ");
                    self.notifyError(self.ERROR['REGISTER_SERVICE']+1,self.name+": Function readLicense() failed : Admira License DOES NOT EXIST ...");
                    self.checking_time = true;
                    self.api_connector.get(self.api_url,self.api_ver,"player/timezone/id","0",self.serverSeedResponse);
                }
            });
        }else{
            self.log("Checking server time for seeding .... ");
        }
    };

    this.serverSeedResponse = function(response,status){
        self.checking_time = false;
        if(status == "success"){
            var timestamp = ""+response; // get UTC timestamp from server
            if(isNaN(timestamp)){
                self.log("Invalid UTC server timestamp for creating license key"+timestamp);
                self.notifyError(self.ERROR['REGISTER_SERVICE']+4,self.name+": Function serverSeedResponse() failed : invalid timestamp from : "+self.api_url+" : "+self.api_ver+" player/timezone/id/0 with response :"+response+" | "+status);
                self.register();
            }else{
                if(timestamp > 0){
                    var temp_key = calcSHA1(timestamp);  // Function from lib/sha.js
                    self.log("Creating Admira License with key ... "+temp_key);
                    self.notifyError(self.ERROR['REGISTER_SERVICE']+5,self.name+": Remote Register KEY success for timestamp : "+timestamp+" generates key : "+temp_key);
                    self.OS.writeFile(self.ROUTES['LICENSE'].path,temp_key,function(ok,file_ref,temp_key_ref){
                        if(ok){
                            self.api_key = temp_key_ref;
                            self.register();
                        }
                    },temp_key);
                }else{
                    self.log("serverSeedResponse ... bad timestamp");
                    self.notifyError(self.ERROR['REGISTER_SERVICE']+6,self.name+": Function serverSeedResponse() failed : response :"+response+" | "+status);
                    self.register();
                }
            }
        }else{
            self.log("serverSeedResponse was NOT success ... starting register again");
            self.notifyError(self.ERROR['REGISTER_SERVICE']+6,self.name+": Function serverSeedResponse() failed : response :"+response+" | "+status);
        }
    };

    this.register = function(callback){
        self.log("Register STATUS api_key : "+self.api_key+" core : "+self.core_id);
        if(typeof(callback) !== "undefined"){
            if(!self.registerCompleteCallback){
                self.registerCompleteCallback = callback;
            }
        }
        if(self.api_key == 0 && self.platform != "ONLINE"){
            self.log("Check Lincense Key ... ");
            self.readLicense();
        }else{
            if(self.core_id <= 0){
                self.log("Checking ID for API_KEY... : "+self.api_key);
                var data = "id="+self.core_id;
                data +="&key="+self.api_key;
                if(self.project_id !== 0){
                  self.log("Auto registering to : "+self.project_id);
                  data +="&project_id="+self.project_id;
                }
                data +="&name=ADMIRA "+(new Date().toLocaleString("es",{timeZone:'UTC'}))+" UTC";
                self.api_connector.post(self.api_url,self.api_ver,"player/register",data,self.registerResponse);
            }else{
                self.log("License OK ID : "+self.core_id+" Key : "+self.api_key);
                self.registered = true;
                if(typeof(self.registerCompleteCallback) !== "undefined"){
                    self.registerCompleteCallback();
                }
            }
        }
    };

    this.checkApiKey = function(){
        if(self.registered){
            if(self.api_key.length >= 40){
                var data = "key="+self.api_key;
                data +="&os="+self.platform;
                self.api_connector.post(self.api_url,self.api_ver,"player/register",data,self.registerResponse);
            }else{
                self.log("Checking API_KEY : Invalid check API KEY "+self.api_key);
                self.notifyError(self.ERROR['REGISTER_SERVICE']+7,self.name+": Function checkApiKey() failed : Checking API_KEY : Invalid check API KEY "+self.api_key);
            }
        }else{
            self.log("Checking API_KEY : not registered yet");
            self.notifyError(self.ERROR['REGISTER_SERVICE']+7,self.name+": Function checkApiKey() failed : Checking API_KEY : not registered yet");
        }
    };

    this.registerResponse = function(response,status,params){
        if(status == "success"){
            self.registered = true;
            var new_core_id = parseInt(response);
            if(isNaN(new_core_id)){
              self.log("Register Response Error");
              self.notifyError(self.ERROR['REGISTER_SERVICE']+2,self.name+": Function registerResponse() failed : Register Response Error : data from response is not a valida Player ID");
            }else{
              if(self.core_id != new_core_id){
                  self.setCoreId(""+new_core_id);
                  self.saveCoreFile();
              }
              self.log("Player is registered with ID : "+self.core_id);
            }
        }else{
            self.log("Register Response Error");
            self.notifyError(self.ERROR['REGISTER_SERVICE']+2,self.name+": Function registerResponse() failed : Register Response Error : "+response+" | "+status);
        }
    };

    this.saveCoreFile = function(){
        var core_xml = '<?xml version="1.0" encoding="utf-8" ?><core><config><id>'+self.core_id+'</id><autoreg>'+self.project_id+'</autoreg><api_ver>'+self.api_ver+'</api_ver><api_url>'+self.api_url+'</api_url></config><server url="'+self.api_server_url+'"/></core>';
        self.log(core_xml);
        self.OS.writeFile(self.ROUTES['CORE'].path,core_xml,function(ok){
            if(ok){
                self.log("Core Saved correctly");
            }else{
                self.log("Error on Core Save file");
                self.notifyError(self.ERROR['REGISTER_SERVICE']+3,self.name+": Function saveCoreFile() failed : Error on Core Save file");
            }
        });
    };
}
RegisterService.prototype = new BasicService();
